---
title: stroke-linejoin
slug: Web/SVG/Attribute/stroke-linejoin
tags:
  - Reference
  - SVG
  - SVG Attribute
  - stroke-linejoin
---
<div>{{SVGRef}}</div>

<p>The <strong><code>stroke-linejoin</code></strong> attribute is a presentation attribute defining the shape to be used at the corners of paths when they are stroked.</p>

<div class="notecard note"><strong>Note:</strong> As a presentation attribute <code>stroke-linejoin</code> can be used as a CSS property.</div>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following nine elements: {{SVGElement('altGlyph')}}, {{SVGElement('path')}}, {{SVGElement('polygon')}}, {{SVGElement('polyline')}}, {{SVGElement('rect')}}, {{SVGElement('text')}}, {{SVGElement('textPath')}}, {{SVGElement('tref')}}, and {{SVGElement('tspan')}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 18 12" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!--
  Upper left path:
  Effect of the "miter" value
  --&gt;
  &lt;path d="M1,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5" stroke="black" fill="none"
        stroke-linejoin="miter" /&gt;

  &lt;!--
  Center path:
  Effect of the "round" value
  --&gt;
  &lt;path d="M7,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5" stroke="black" fill="none"
        stroke-linejoin="round" /&gt;

  &lt;!--
  Upper right path:
  Effect of the "bevel" value
  --&gt;
  &lt;path d="M13,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5" stroke="black" fill="none"
        stroke-linejoin="bevel" /&gt;

  &lt;!--
  Bottom left path:
  Effect of the "miter-clip" value
  with fallback to "miter" if not supported.
  --&gt;
  &lt;path d="M3,11 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5" stroke="black" fill="none"
        stroke-linejoin="miter-clip" /&gt;

  &lt;!--
  Bottom right path:
  Effect of the "arcs" value
  with fallback to "miter" if not supported.
  --&gt;
  &lt;path d="M9,11 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5" stroke="black" fill="none"
        stroke-linejoin="arcs" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;g id="highlight"&gt;
    &lt;path d="M1,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3.5"
          stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5"   r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2"   r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5.5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
  &lt;use xlink:href="#highlight" x="6" /&gt;
  &lt;use xlink:href="#highlight" x="12" /&gt;
  &lt;use xlink:href="#highlight" x="2" y="6" /&gt;
  &lt;use xlink:href="#highlight" x="8" y="6" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('topExample', '100%', 400)}}</p>
</div>

<h2 id="Usage_context">Usage context</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>arcs</code> | <code>bevel</code> |<code>miter</code> | <code>miter-clip</code> | <code>round</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>miter</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<h3 id="arcs">arcs</h3>

<div class="notecard note"><strong>Note:</strong> the <code>arcs</code> value as been introduced in SVG2 and it isn't widely supported yet, see <a href="#Browser_compatibility">Browser compatibility</a> bellow for details.</div>

<p>The <code>arcs</code> value indicates that an arcs corner is to be used to join path segments. The arcs shape is formed by extending the outer edges of the stroke at the join point with arcs that have the same curvature as the outer edges at the join point.</p>

<h4 id="Example">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 6" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!-- Effect of the "arcs" value --&gt;
  &lt;path d="M1,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3" stroke="black" fill="none"
        stroke-linejoin="arcs" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;g id="p"&gt;
    &lt;path d="M1,5 a2,2 0,0,0 2,-3 a3,3 0 0 1 2,3"
          stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('arcs', '100%', 200)}}</p>

<h3 id="bevel">bevel</h3>

<p>The <code>bevel</code> value indicates that a bevelled corner is to be used to join path segments.</p>

<h4 id="Example_2">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 6" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!-- Effect of the "bevel" value --&gt;
  &lt;path d="M1,5 l2,-3 l2,3" stroke="black" fill="none"
        stroke-linejoin="bevel" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;g id="p"&gt;
    &lt;path d="M1,5 l2,-3 l2,3"
          stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('bevel', '100%', 200)}}</p>

<h3 id="miter">miter</h3>

<p>The <code>miter</code> value indicates that a sharp corner is to be used to join path segments. The corner is formed by extending the outer edges of the stroke at the tangents of the path segments until they intersect.</p>

<div class="notecard note"><strong>Note:</strong> If the {{SVGAttr('stroke-miterlimit')}} is exceeded, the line join falls back to <code>bevel</code>.</div>

<h4 id="Example_3">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 -1 10 7" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!-- Effect of the "miter" value --&gt;
  &lt;path d="M1,5 l2,-3 l2,3" stroke="black" fill="none"
        stroke-linejoin="miter" /&gt;

  &lt;!-- Effect of the "miter" value on a sharp angle
       where de default miter limit is exceeded --&gt;
  &lt;path d="M7,5 l0.75,-3 l0.75,3" stroke="black" fill="none"
        stroke-linejoin="miter" /&gt;

  &lt;!-- the following red dotted line show where
       the miter value falls back to the bevel value --&gt;
  &lt;path d="M0,0 h10" stroke="red" stroke-dasharray="0.05"  stroke-width="0.025"/&gt;

  &lt;!-- the following pink lines highlight the position of the path for each stroke --&gt;
  &lt;g&gt;
    &lt;path d="M1,5 l2,-3 l2,3" stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5" r="0.05" fill="pink" /&gt;

    &lt;path d="M7,5 l0.75,-3 l0.75,3" stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="7"    cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="7.75" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="8.5"  cy="5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('miter', '100%', 200)}}</p>

<h3 id="miter-clip">miter-clip</h3>

<div class="notecard note"><strong>Note:</strong> the <code>miter-clip</code> value as been introduced in SVG2 and it isn't widely supported yet, see <a href="#Browser_compatibility">Browser compatibility</a> bellow for details.</div>

<p>The <code>miter-clip</code> value indicates that a sharp corner is to be used to join path segments. The corner is formed by extending the outer edges of the stroke at the tangents of the path segments until they intersect.</p>

<p>If the {{SVGAttr('stroke-miterlimit')}} is exceeded, the miter is clipped at a distance equal to half the {{SVGAttr('stroke-miterlimit')}} value multiplied by the stroke width from the intersection of the path segments. This provides a better rendering than <code>miter</code> on very sharp join or in case of an animation.</p>

<h4 id="Example_4">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 -1 10 7" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!-- Effect of the "miter-clip" value --&gt;
  &lt;path d="M1,5 l2,-3 l2,3" stroke="black" fill="none"
        stroke-linejoin="miter-clip" /&gt;

  &lt;!-- Effect of the "miter-clip" value on a sharp angle
       where de default miter limit is exceeded --&gt;
  &lt;path d="M7,5 l0.75,-3 l0.75,3" stroke="black" fill="none"
        stroke-linejoin="miter-clip" /&gt;

  &lt;!-- the following red dotted line show where the clip should happen --&gt;
  &lt;path d="M0,0 h10" stroke="red" stroke-dasharray="0.05"  stroke-width="0.025"/&gt;

  &lt;!-- the following pink lines highlight the position of the path for each stroke --&gt;
  &lt;g&gt;
    &lt;path d="M1,5 l2,-3 l2,3" stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5" r="0.05" fill="pink" /&gt;

    &lt;path d="M7,5 l0.75,-3 l0.75,3" stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="7"    cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="7.75" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="8.5"  cy="5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('miter-clip', '100%', 200)}}</p>

<h3 id="round">round</h3>

<p>The <code>round</code> value indicates that a round corner is to be used to join path segments.</p>

<h4 id="Example_5">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 6" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;!-- Effect of the "round" value --&gt;
  &lt;path d="M1,5 l2,-3 l2,3" stroke="black" fill="none"
        stroke-linejoin="round" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;g id="p"&gt;
    &lt;path d="M1,5 l2,-3 l2,3"
          stroke="pink" fill="none" stroke-width="0.025" /&gt;
    &lt;circle cx="1" cy="5" r="0.05" fill="pink" /&gt;
    &lt;circle cx="3" cy="2" r="0.05" fill="pink" /&gt;
    &lt;circle cx="5" cy="5" r="0.05" fill="pink" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('round', '100%', 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#StrokeLinejoinProperty", "stroke-linejoin")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Definition for shapes and texts</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "painting.html#StrokeLinejoinProperty", "stroke-linejoin")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition for shapes and texts</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.stroke-linejoin")}}</p>
